diff --git a/shared/js/weston.ruter.net/webforms2/webforms2_src.js b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
index f15d8ee..5a8b110 100644
--- a/shared/js/weston.ruter.net/webforms2/webforms2_src.js
+++ b/shared/js/weston.ruter.net/webforms2/webforms2_src.js
@@ -1426,9 +459,10 @@ $wf2 = {
 	initNonRepetitionFunctionality : function(parent){
 		parent = (parent || document.documentElement);
 		var i,j, frm, frms = parent.getElementsByTagName('form');
-		for(i = 0; frm = frms[i]; i++){
-			if(frm.checkValidity && !$wf2.hasBadImplementation)
+		for(i = 0; frm = frms[i]; i++){
+			if(frm.checkValidity && !$wf2.hasBadImplementation && $wf2.getAttributeValue(frm, 'data-webforms2-force-js-validation') != 'true') {
 				continue;
+			}
 			frm.checkValidity = $wf2.formCheckValidity;
 			
 			if(frm.addEventListener)
@@ -1509,13 +543,31 @@ $wf2 = {
 		var formElements = $wf2.getFormElements.apply(this);
 		//for(i = 0; i < formElements.length; i++)
 		//	_elements.push(formElements[i]);
-		for(i = 0; el = formElements[i]; i++){
+		for(i = 0; el = formElements[i]; i++){ 
 			var type = (el.getAttribute('type') ? el.getAttribute('type').toLowerCase() : el.type);
-			el.willValidate = !(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !el.name || el.disabled)
+			
+			try {
+				el.willValidate = !(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !el.name || el.disabled)
+			} catch (ex) {
+				// do nothing.
+			}
 			//Then, each element in this list whose willValidate DOM attribute is true is checked for validity
 			if(el.checkValidity && el.willValidate){
-				if(!el.checkValidity())
+				if(!el.checkValidity() && el.checkValidity() != undefined) {
 					valid = false;
+					
+					/* var oninvalid = el.getAttribute('oninvalid');
+					if (oninvalid) {
+						oninvalid();
+					} */
+					
+					
+					/* we change this to only show the first error.
+					if (!$wf2.showAllErrors) {
+						break;
+					}
+					*/
+				}
 			}
 		}
 		
@@ -1528,10 +580,13 @@ $wf2 = {
 	hiliteFirstError: function () {
 		
 		if($wf2.invalidIndicators.length){ //second condition needed because modal in oninvalid handler may cause indicators to disappear before this is reached
-			$wf2.invalidIndicators[0].errorMsg.className += " wf2_firstErrorMsg";
-			
+			//$wf2.invalidIndicators[0].errorMsg.className += " wf2_firstErrorMsg";
+			$wf2.css.addClass($wf2.invalidIndicators[0].errorMsg, "wf2_firstErrorMsg");
 			//scroll to near the location where invalid control is
 			el = $wf2.invalidIndicators[0].target;
+			
+			var doScroll = (el.form.getAttribute('data-wf2-no-scroll-on-error') != 'true')
+			
 			if(el.style.display == 'none' || !el.offsetParent){
 				while(el && (el.nodeType != 1 || (el.style.display == 'none' || !el.offsetParent)))
 					el = el.previousSibling;
@@ -1542,7 +597,9 @@ $wf2 = {
 					while (cur = cur.offsetParent)
 						top += cur.offsetTop;
 				}
-				scrollTo(0, top);
+				if (doScroll) {
+					scrollTo(0, top);
+				}
 			}
 			//focus on the first invalid control and make sure error message is visible
 			else {
@@ -1554,15 +611,24 @@ $wf2 = {
 					}
 				, 10)
 				
+				
+				var elPos = $wf2.css.getAbsoluteCoords(el);
+				var maxBottom = $wf2.css.getScrollY() + $wf2.css.getWindowHeight();
+				var errorMsgHeight = $wf2.invalidIndicators[0].errorMsg.offsetHeight;
+				
+				console.log(elPos.y + errorMsgHeight, maxBottom)
 				//NOTE: We should only do this if the control's style.bottom == 0
-				scrollBy(0, $wf2.invalidIndicators[0].errorMsg.offsetHeight);
+				if (doScroll && elPos.y + errorMsgHeight > maxBottom) {
+					
+					scrollBy(0, errorMsgHeight );
+				}
 			}
 		}
 		
 	},
 	
 	controlCheckValidity : function(){
-		$wf2.controlCheckValidityOfElement(this);
+		return $wf2.controlCheckValidityOfElement(this);
 		
 	},
 	
@@ -1617,9 +683,10 @@ $wf2 = {
 			}
 		}
 		catch(err){
+			var myErr = err;
 			//throw exception within setTimeout so that the current execution will not be aborted
 			setTimeout(function(){
-				throw err;
+				throw myErr;
 			}, 0);
 		}
 
@@ -1680,17 +747,19 @@ $wf2 = {
 	getOriginalAttrNode: function (node, attrName) {
 		var r;
 		
-		var dataSetItemName = attrName + 'AttrNode';
+		/* var dataSetItemName = attrName + 'AttrNode';
 		
 		if ($wf2.getDatasetItem(node, dataSetItemName) == null) {
 			r = $wf2.copyOf(node.getAttributeNode(attrName));
-			$wf2.setDatasetItem(node, dataSetItemName, r);
+			$wf2.setDatasetItem(node, dataSetItemName, r.value);
 		} else {
 			r = $wf2.getDatasetItem(node, dataSetItemName);
 			if (r == 'null') {
 				r = null;
 			}
-		}
+		} */
+		
+		r = $wf2.copyOf(node.getAttributeNode(attrName));
 		
 		return r;
 	},
@@ -1699,26 +768,36 @@ $wf2 = {
 	updateValidityState : function(node){
 		//if(node.form && node.form[node.name] && node.form[node.name].wf2HasInvalidIndicator)
 		//	return;
+		var type = (node.getAttribute('type') ? node.getAttribute('type').toLowerCase() : node.type);
+		// for range, we need to make sure this doesn't run
+		if (type == 'range' && node.type == 'range') {
+			return;
+		}
+		
 		
 		var minAttrNode, maxAttrNode, valueAttrNode;
 		
 		minAttrNode = $wf2.getOriginalAttrNode(node, 'min');
 		maxAttrNode = $wf2.getOriginalAttrNode(node, 'max');
+		stepAttrNode = $wf2.getOriginalAttrNode(node, 'step');
 		valueAttrNode = $wf2.getOriginalAttrNode(node, 'value');
-
+		
+		
 		node.min = undefined; //wf2Min
 		node.max = undefined; //wf2Max
 		node.step = undefined; //wf2Step
 		
+		// only do this if node.validity is set, or Opera will complain.
+		if (!node.validity) {
+			node.validity = $wf2.createValidityState();
+		}
 		
-		
-		node.validity = $wf2.createValidityState();
 		node.validity.customError = !!node.validationMessage;
 		
 		//var type = node.type ? node.type.toLowerCase() : 'text';
 		//var type = (node.type ? node.getAttribute('type').toLowerCase() :
 		//                       (node.nodeName.toLowerCase() == 'input' ? 'text' : ''));
-		var type = (node.getAttribute('type') ? node.getAttribute('type').toLowerCase() : node.type);
+		
 		var isTimeRelated = (type == 'datetime' || type == 'datetime-local' || type == 'time'); //datetime, datetime-local, time
 		var isDateRelated = (type == 'date' || type == 'month' || type == 'week'); //date, month, week
 		var isNumberRelated = (type == 'number' || type == 'range'); //number, range
@@ -1748,22 +827,37 @@ $wf2 = {
 		
 		if(type == 'range'){
 			//For this type...min defaults to 0...and value defaults to the min value.
+			
 			node.min = (minAttrNode && $wf2.numberRegExp.test(minAttrNode.value)) ? Number(minAttrNode.value) : 0;
+			node.max = (maxAttrNode && $wf2.numberRegExp.test(maxAttrNode.value)) ? Number(maxAttrNode.value) : 0;
 			if((!valueAttrNode || !valueAttrNode.specified) && node.value === '' && !node.wf2ValueProvided){ //(!valueAttrNode || !valueAttrNode.specified) && 
 				node.setAttribute('value', node.min);
 				node.value = node.min;
 				node.wf2ValueProvided = true;
 			}
+			
+			return;
 		}
 		
-		node.wf2Value = node.value;
+		if ($wf2.css.isMemberOfClass(node, 'html5-hasPlaceholderText')) {
+			node.wf2Value = '';
+		} else {
+			node.wf2Value = node.value;
+		}
+		//console.log("changing:", node.value, ", " , node.wf2Value)
 
 		//valueMissing -- The control has the required attribute set but it has not been satisfied.
 		//The required attribute applies to all form controls except controls with the type hidden,
 		//   image inputs, buttons (submit, move-up, etc), and select and output elements. For
 		//   disabled or readonly controls, the attribute has no effect.
 		var type = (node.getAttribute('type') ? node.getAttribute('type').toLowerCase() : node.type);
-		node.willValidate = !(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !node.name || node.disabled);
+		
+		// do this only when node.willValidate doesn't exist or Opera will complain
+		try {
+			node.willValidate = !(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !node.name || node.disabled);
+		} catch (ex) {
+			// do nothing.
+		}
 		if(doRequiredCheck && node.willValidate){
 			//For checkboxes, the required  attribute shall only be satisfied when one or more of
 			//  the checkboxes with that name in that form are checked.
@@ -1805,13 +899,13 @@ $wf2 = {
 				//For other controls, any non-empty value shall satisfy the required condition,
 				//   including a simple whitespace character.
 				//else
-					node.validity.valueMissing = (node.value == '');
+					node.validity.valueMissing = (node.wf2Value == '');
 			}
 			//if(node.options ? node.selectedIndex == -1 : node.value === '')
 			//	node.validity.valueMissing = true;
 			//
 		}
-		if(!node.validity.valueMissing && node.value){
+		if(!node.validity.valueMissing && node.wf2Value){
 			//patternMismatch -- The value of the control with a pattern attribute doesn't match the pattern. 
 			//   If the control is empty, this flag must not be set.
 			//If the pattern attribute is present but empty, it doesn't match any value, and thus the
@@ -1828,20 +922,21 @@ $wf2 = {
 				//When the pattern is not a valid regular expression, it is ignored for the purposes of
 				//   validation, as if it wasn't specified.
 				if(rePattern)
-					node.validity.patternMismatch = !rePattern.test(node.value);
+					node.validity.patternMismatch = !rePattern.test(node.wf2Value);
 			}
 			
 			//typeMismatch -- The data entered does not match the type of the control. For example, if the UA 
 			//   allows uninterpreted arbitrary text entry for month controls, and the user has entered SEP02, 
 			//   then this flag would be set. This code is also used when the selected file in a file upload 
 			//   control does not have an appropriate MIME type. If the control is empty, this flag must not be set.
-			if(isDateRelated || isTimeRelated)
-				node.validity.typeMismatch = ((node.wf2Value = $wf2.parseISO8601(node.value, type)) == null);
-			else {
+			if(isDateRelated || isTimeRelated) {
+				//node.validity.typeMismatch = ((node.value = $wf2.parseISO8601(node.wf2Value, type)) == null);
+				//node.wf2Value = node.value;
+			} else {
 				switch(type){
 					case 'number':
 					case 'range':
-						node.validity.typeMismatch = !$wf2.numberRegExp.test(node.value);
+						node.validity.typeMismatch = !$wf2.numberRegExp.test(node.wf2Value);
 	//						if(!node.validity.typeMismatch && node.getAttribute("step") != 'any'){
 	//							if(node.step == undefined)
 	//								node.step = 1;
@@ -1855,7 +950,7 @@ $wf2 = {
 						//   subtoken everywhere except in the quoted-string subtoken. UAs could, for example, offer
 						//   e-mail addresses from the user's address book. (See below for notes on IDN.)
 						//http://www.ietf.org/rfc/rfc2822						
-						node.validity.typeMismatch = !$wf2.emailRegExp.test(node.value);
+						node.validity.typeMismatch = !$wf2.emailRegExp.test(node.wf2Value);
 						break;
 					case 'url':
 						//An IRI, as defined by [RFC3987] (the IRI token, defined in RFC 3987 section 2.2). UAs could,
@@ -1864,7 +959,7 @@ $wf2 = {
 						//   generally felt authors are more familiar with the term "URL" than the other, more technically
 						//   correct terms.
 						//http://www.ietf.org/rfc/rfc3987
-						node.validity.typeMismatch = !$wf2.urlRegExp.test(node.value);
+						node.validity.typeMismatch = !$wf2.urlRegExp.test(node.wf2Value);
 						break;
 				}
 			}
@@ -1885,6 +980,8 @@ $wf2 = {
 						if(type == 'range'){
 							//For this type...max defaults to 100
 							node.max = (maxAttrNode && $wf2.numberRegExp.test(maxAttrNode.value)) ? Number(maxAttrNode.value) : 100;
+							
+							
 							//node.min is set at the beginning of this function so that the min value can be set as the default value
 						}
 						else {
@@ -1892,9 +989,13 @@ $wf2 = {
 								node.min = Number(minAttrNode.value);
 							if(maxAttrNode && $wf2.numberRegExp.test(maxAttrNode.value))
 								node.max = Number(maxAttrNode.value);
+							if(stepAttrNode && $wf2.numberRegExp.test(stepAttrNode.value))
+								node.step = Number(stepAttrNode.value);
 						}
-						node.validity.rangeUnderflow = (node.min != undefined && Number(node.value) < node.min);
-						node.validity.rangeOverflow  = (node.max != undefined && Number(node.value) > node.max);
+						node.validity.rangeUnderflow = (node.min != undefined && Number(node.wf2Value) < node.min);
+						node.validity.rangeOverflow  = (node.max != undefined && Number(node.wf2Value) > node.max);
+						node.validity.stepMismatch = !$wf2.isValidNumber(node);
+						//console.log('first: ', node.validity.stepMismatch, ',', node.getAttribute('type'))
 					}
 					//For file types it must be a sequence of digits 0-9, treated as a base ten integer.
 					else if(type == 'file'){
@@ -1928,12 +1029,15 @@ $wf2 = {
 					}
 				}
 				//The step attribute controls the precision allowed for the date-related, time-related, and numeric types.
-				if(doCheckPrecision && !node.validity.rangeUnderflow && !node.validity.rangeOverflow){
+				
+				//Note: webforms2 as of March 6, 2012 does not support step for time related inputs.  Will revisit later.
+				if(!(isDateRelated || isTimeRelated) && doCheckPrecision && !node.validity.rangeUnderflow && !node.validity.rangeOverflow){
 					//stepMismatch -- The value is not one of the values allowed by the step attribute, and the UA will 
 					//   not be rounding the value for submission. Empty values and values that caused the typeMismatch 
 					//   flag to be set must not cause this flag to be set.
 					
 					var stepAttrNode = $wf2.getOriginalAttrNode(node, 'step'); //node.getAttributeNode('step');
+					
 					if(!stepAttrNode){
 						//The step attribute [for types datetime, datetime-local, and time] ... defaulting to 60 (one minute).
 						//For time controls, the value of the step attribute is in seconds, although it may be a fractional
@@ -1975,9 +1079,9 @@ $wf2 = {
 						//   and for time controls is 00:00.
 						var _step = node.step;
 						if(type == 'month' && node.wf2StepDatum && node.wf2StepDatum.getUTCFullYear){
-							var month1 = node.wf2StepDatum.getUTCFullYear()*12 + node.wf2StepDatum.getUTCMonth();
-							var month2 = node.wf2Value.getUTCFullYear()*12 + node.wf2Value.getUTCMonth();
-							node.validity.stepMismatch = (month2 - month1)%_step != 0;
+							//var month1 = node.wf2StepDatum.getUTCFullYear()*12 + node.wf2StepDatum.getUTCMonth();
+							//var month2 = node.wf2Value.getUTCFullYear()*12 + node.wf2Value.getUTCMonth();
+							//node.validity.stepMismatch = (month2 - month1)%_step != 0;
 						}
 						else {
 							switch(type){
@@ -2007,13 +1111,13 @@ $wf2 = {
 			//   and the value of the control doesn't exactly match the control's default value. 
 			//[The maxlength] attribute must not affect the initial value (the DOM defaultValue attribute). It must only
 			//   affect what the user may enter and whether a validity error is flagged during validation.
-			if(doMaxLengthCheck && node.maxLength >= 0 && node.value != node.defaultValue){
+			if(doMaxLengthCheck && node.maxLength >= 0 && node.wf2Value != node.defaultValue){
 				//A newline in a textarea's value must count as two code points for maxlength processing (because
 				//   newlines in textareas are submitted as U+000D U+000A). [[NOT IMPLEMENTED: This includes the
 				//   implied newlines that are added for submission when the wrap attribute has the value hard.]]
 				//var matches = node.value.match(/((?<!\x0D|^)\x0A|\x0D(?!^\x0A|$))/g); //no negative lookbehind
 				var shortNewlines = 0;
-				var v = node.value;
+				var v = node.wf2Value;
 				node.wf2ValueLength = v.length;
 				for(var i = 1; i < v.length; i++){
 					if(v[i] === "\x0A" && v[i-1] !== "\x0D" || v[i] == "\x0D" && (v[i+1] && v[i+1] !== "\x0A"))
@@ -2024,12 +1128,29 @@ $wf2 = {
 				//   has more than the specified number of code points and the value doesn't match the control's default value.
 				node.validity.tooLong = node.wf2ValueLength > node.maxLength;
 			}
+		} else {
+			if(minAttrNode && $wf2.numberRegExp.test(minAttrNode.value))
+				node.min = Number(minAttrNode.value);
+			if(maxAttrNode && $wf2.numberRegExp.test(maxAttrNode.value))
+				node.max = Number(maxAttrNode.value);
+			if(stepAttrNode && $wf2.numberRegExp.test(stepAttrNode.value))
+				node.step = Number(stepAttrNode.value);
 		}
 
 		//customError -- The control was marked invalid from script. See the definition of the setCustomValiditiy() method.
-		
+		//console.log('second: ', node.validity.stepMismatch)
 		node.validity.valid = !$wf2.hasInvalidState(node.validity);
-		
+		if (node.validity.valid) {
+			$wf2.css.removeClass(node, 'wf2_invalid');
+			$wf2.css.addClass(node, 'wf2_valid');
+			//node.className = node.className.replace(/\s?wf2_invalid/g, "") + ' wf2_valid';
+			//console.log('valid: ', node.className)
+		} else { 
+			$wf2.css.removeClass(node, 'wf2_valid');
+			$wf2.css.addClass(node, 'wf2_invalid');
+			//node.className = node.className.replace(/\s?wf2_valid/g, "") + ' wf2_invalid';
+			//console.log('not valid: ', node.className, 'value:', node.value, 'wtfValue:', node.wf2Value)
+		}
 		//This is now done onmousedown or onkeydown, just as Opera does
 		//if(node.validity.valid){
 		//	node.className = node.className.replace(/\s*\binvalid\b\s*/g, " "); //substitute for :invalid pseudo class
@@ -2042,12 +1163,20 @@ $wf2 = {
 		//		errMsg.parentNode.removeChild(errMsg);
 		//}
 	},
+	
+	// checks to see if a number node has a value that is valid.
+	isValidNumber: function (node) {
+		//console.log(node.wf2Value + ", " + node.min + ", " + node.max + ", " + node.step);
+		var n = (parseFloat(node.wf2Value) - parseFloat(node.min))/parseFloat(node.step);
+		//console.log('!' , n == parseInt(n))
+		return (n == parseInt(n));
+	},
 
 	applyValidityInterface : function(node){
 		
 		/* Webkit browsers need this */
-		if ($wf2.hasBadImplementation) {
-			
+		if (!$wf2.hasNativeBubbles || (node.form && $wf2.getAttributeValue(node.form, 'data-webforms2-force-js-validation') == 'true')) {
+			console.log(node.name)
 			if (node.type == 'submit' || node.type == 'button') {
 				
 				node.formNoValidate=true;
@@ -2055,18 +1184,22 @@ $wf2 = {
 			}
 		}
 	
-		/* ZOLTAN made a change here to ensure Google's unfinished native implementation is not used. */
+		/* Made a change here to ensure Google's unfinished native implementation is not used. */
 		else if((node.validity && node.validity.typeMismatch !== undefined)) {//MSIE needs the second test for some reason
 			//	console.log('bad implementation!! ' + node.id);
 			
 			return node;
 		}
+		
+		try {
 		node.validationMessage = "";
 		
 		//ValidityState interface
 		node.validity = $wf2.createValidityState();
 		node.willValidate = true;
-		
+		} catch (ex) {
+			// do nothing.
+		}
 		var nodeName = node.nodeName.toLowerCase();
 		if(nodeName == 'button' || nodeName == 'fieldset'){
 			node.setCustomValidity = function(error){
@@ -2090,39 +1223,58 @@ $wf2 = {
 		//var type = (node.type ? node.type.toLowerCase() : (nodeName == 'input' ? 'text' : ''));
 		var type = (node.getAttribute('type') ? node.getAttribute('type').toLowerCase() : node.type);
 		
-		if(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !node.name || node.disabled)
-			node.willValidate = false;
+		if(/(hidden|button|reset|add|remove|move-up|move-down)/.test(type) || !node.name || node.disabled) {
+			try {
+				node.willValidate = false;
+			} catch (ex) {
+				// do nothing.
+			}
+		}
 		else if(window.RepetitionElement) {
 			var parent = node;
 			while(parent = parent.parentNode){
 				if(parent.repetitionType == RepetitionElement.REPETITION_TEMPLATE){
-					node.willValidate = false;
+					try {
+						node.willValidate = false;
+					} catch (ex) {
+						// do nothing.
+					}
 					break;
 				}
 			}
 		}
 		
-		//var handler = function(event){
-		//	return (event.currentTarget || event.srcElement)._updateValidityState();
-		//};
 		
-		////attempt to check validity live
-		//if(document.addEventListener){
-		//	node.addEventListener('change', handler, false);
-		//	node.addEventListener('blur', handler, false);
-		//	node.addEventListener('keyup', handler, false);
-		//}
-		//else if(window.attachEvent){
-		//	node.attachEvent('onchange', handler);
-		//	node.attachEvent('onblur', handler);
-		//	node.attachEvent('onkeyup', handler);
-		//}
-		//else {
-		//
-		//}
+		
+		var handler = function(event){
+			return $wf2.updateValidityState(event.currentTarget || event.srcElement);
+		};
+		
+		//attempt to check validity live
+		if(document.addEventListener){
+			node.addEventListener('change', handler, false);
+			node.addEventListener('blur', handler, false);
+			node.addEventListener('keyup', handler, false);
+		}
+		else if(window.attachEvent){
+			node.attachEvent('onchange', handler);
+			node.attachEvent('onblur', handler);
+			node.attachEvent('onkeyup', handler);
+		}
+		else {
+		
+		}
 		
 		return node;
 	},
+	
+	/* updateValidityState: function (node) {
+		if (node.checkValidity()){
+			node.className = node.className.replace(/\s?wf2_invalid/, "");
+		} else {
+			node.className += ' wf2_invalid';
+		}
+	}, */
 
 	onsubmitValidityHandler : function(event){
 		var frm = event.currentTarget || event.srcElement;
@@ -2134,7 +1286,7 @@ $wf2 = {
 			$wf2.callBeforeValidation[i](event);
 		}
 		
-		/* ZOLTAN */
+		
 		if(!frm.checkValidity()){
 			if(event.preventDefault)
 				event.preventDefault();
@@ -2207,13 +1359,13 @@ $wf2 = {
 	},
 
 	invalidMessages : {
-		valueMissing   : 'A value must be supplied or selected.',
-		typeMismatch   : 'The value is invalid for %s type.',
+		valueMissing   : 'Please fill out this field.',
+		typeMismatch   : 'Please enter a valid %s.',
 		rangeUnderflow : 'The value must be equal to or greater than %s.',
 		rangeOverflow  : 'The value must be equal to or less than %s.',
 		stepMismatch   : 'The value has a step mismatch; it must be a certain number multiples of %s from %s.',
 		tooLong        : 'The value is too long. The field may have a maximum of %s characters but you supplied %s. Note that each line-break counts as two characters.',
-		patternMismatch: 'The value is not in the format required.'
+		patternMismatch: 'Please match the requested format.'
 	},
 	
 	valueToWF2Type : function(value, type){
@@ -2233,7 +1385,14 @@ $wf2 = {
 	addInvalidIndicator : function(target){
 		//show contextual help message
 		var msg = document.createElement('div');
-		msg.className = 'wf2_errorMsg';
+		msg.className = 'wf2_errorMsg wf2_fromForm_' + (target.form.id || target.form.name);
+		
+		/* Let's put in a container in here so IE9- can put a gradient filter in here. */
+		var msgContainer = document.createElement('div');
+		msgContainer.className = 'wf2_errorMsgContainer';
+		msg.appendChild(msgContainer);
+		
+		
 		//msg.title = "Close";
 		msg.id = (target.id || target.name) + '_wf2_errorMsg'; //QUESTION: does this work for MSIE?
 		msg.onmousedown = function(){
@@ -2245,27 +1404,29 @@ $wf2 = {
 		var isDateTimeRelated = (type == 'datetime' || type == 'datetime-local' || type == 'time' || type == 'date' || type == 'month' || type == 'week');
 
 		var ol = document.createElement('ol');
-		if(target.validity.valueMissing)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.valueMissing));
-		if(target.validity.typeMismatch)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.typeMismatch.replace(/%s/, type)));
-		if(target.validity.rangeUnderflow)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.rangeUnderflow.replace(/%s/, $wf2.valueToWF2Type(target.min, type))));
-		if(target.validity.rangeOverflow)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.rangeOverflow.replace(/%s/, $wf2.valueToWF2Type(target.max, type))));
-		if(target.validity.stepMismatch)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.stepMismatch.replace(/%s/, target.step + ($wf2.stepUnits[type] ? ' ' + $wf2.stepUnits[type] + '(s)' : '')).replace(/%s/, $wf2.valueToWF2Type(target.wf2StepDatum, type))));
-		if(target.validity.tooLong)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.tooLong.replace(/%s/, target.maxLength).replace(/%s/, target.wf2ValueLength ? target.wf2ValueLength : target.value.length)));
-		if(target.validity.patternMismatch)
-			ol.appendChild($wf2.createLI($wf2.invalidMessages.patternMismatch.replace(/%s/, target.title ? target.title : ' "' + target.getAttribute('pattern') + '"')));
-		if(target.validity.customError)
+		if(target.validity.customError) {
 			ol.appendChild($wf2.createLI(target.validationMessage));
+		} else {
+			if(target.validity.valueMissing)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.valueMissing));
+			if(target.validity.typeMismatch)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.typeMismatch.replace(/%s/, type)));
+			if(target.validity.rangeUnderflow)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.rangeUnderflow.replace(/%s/, $wf2.valueToWF2Type(target.min, type))));
+			if(target.validity.rangeOverflow)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.rangeOverflow.replace(/%s/, $wf2.valueToWF2Type(target.max, type))));
+			if(target.validity.stepMismatch)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.stepMismatch.replace(/%s/, target.step + ($wf2.stepUnits[type] ? ' ' + $wf2.stepUnits[type] + '(s)' : '')).replace(/%s/, $wf2.valueToWF2Type(target.wf2StepDatum, type))));
+			if(target.validity.tooLong)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.tooLong.replace(/%s/, target.maxLength).replace(/%s/, target.wf2ValueLength ? target.wf2ValueLength : target.value.length)));
+			if(target.validity.patternMismatch)
+				ol.appendChild($wf2.createLI($wf2.invalidMessages.patternMismatch.replace(/%s/, target.title ? target.title : ' "' + target.getAttribute('pattern') + '"')));
+		}
 		
 		if(ol.childNodes.length == 1)
 			ol.className = 'single';
 		
-		msg.appendChild(ol);
+		msgContainer.appendChild(ol);
 		////remove existing error message
 		//if(document.getElementById(msg.id))
 		//	document.documentElement.removeChild(document.getElementById(msg.id));
@@ -2294,15 +1455,13 @@ $wf2 = {
 		
 		var top = left = 0;
 		var cur = el;
-		if(cur && cur.offsetParent){
-			left = cur.offsetLeft;
-			top = cur.offsetTop;
-			while(cur = cur.offsetParent){
-				left += cur.offsetLeft;
-				top += cur.offsetTop;
-			}
-			top += el.offsetHeight;
-		}
+		
+		
+		var s = $wf2.css.getAbsoluteCoords(el);	
+		top = s.y + el.offsetHeight;
+		left = s.x;	
+		
+		
 		msg.style.top = top + 'px';
 		msg.style.left = left + 'px';
 		
@@ -2314,23 +1473,34 @@ $wf2 = {
 		//	target.form[target.name].wf2HasInvalidIndicator = true;
 		//	console.info('set')
 		//}
-		if(!target.className.match(/\bwf2_invalid\b/))
-			target.className += " wf2_invalid";
+		/* if(!target.className.match(/\bwf2_invalid\b/))
+			target.className += " wf2_invalid"; */
+		$wf2.css.addClass(target, 'wf2_invalid');
 			
 		if($wf2.indicatorIntervalId == null){
 			//var i = $wf2.invalidIndicators.length - 1;
 			$wf2.indicatorIntervalId = setInterval(function(){
 				var invalidIndicator;
 				for(var i = 0; invalidIndicator = $wf2.invalidIndicators[i]; i++){
+					
+					if (!$wf2.css.isMemberOfClass(invalidIndicator.target, 'wf2_invalid')) {
+						$wf2.css.addClass(invalidIndicator.target, 'wf2_invalid')
+					} else {
+						$wf2.css.removeClass(invalidIndicator.target, 'wf2_invalid');
+					}
+					
+					
+					/* 
 					if(!invalidIndicator.target.className.match(/\bwf2_invalid\b/)){
 						invalidIndicator.target.className += " wf2_invalid";
 					}
 					else {
 						invalidIndicator.target.className = invalidIndicator.target.className.replace(/\s?wf2_invalid/, "");
-					}
+					} */
 				}
 				
 			}, 500);
+			return;
 			// call routines other libraries have set to be run before
 			// validation.
 			setTimeout(function() {
@@ -2355,9 +1525,9 @@ $wf2 = {
 				invalidIndicator.errorMsg.parentNode.removeChild(invalidIndicator.errorMsg);
 			//clearInterval(insts[0].intervalId);
 			var target = invalidIndicator.target;
-			//if(target.form && target.form[target.name])
-			//	target.form[target.name].wf2HasInvalidIndicator = false;
-			target.className = target.className.replace(/\s?wf2_invalid/, ""); //([^\b]\s)?
+			
+			// Removed
+			// target.className = target.className.replace(/\s?wf2_invalid/, ""); //([^\b]\s)?
 			$wf2.invalidIndicators.shift();
 		}
 		
@@ -2422,6 +1592,7 @@ $wf2 = {
 				//	  : document.createElement(node.nodeName);
 						
 				for(i = 0; attr = node.attributes[i]; i++){
+					
 					//MSIE ISSUE: Custom attributes specified do not have .specified property set to true?
 					//ISSUE: VALUE IS REPEATED IN MSIE WHEN VALUE ATTRIBUTE SET?
 					//if(attr.specified || node.getAttribute(attr.nodeName)) //$wf2.cloneNode_customAttrs[attr.nodeName] || 
@@ -2435,6 +1606,7 @@ $wf2 = {
 								(!isTemplate || (rtNestedDepth > 1 || !$wf2.cloneNode_rtEventHandlerAttrs[attr.name])) // && 
 							))
 					{
+						
 						//MSIE BUG: when button[type=add|remove|move-up|move-down], then (attr.nodeValue and attr.value == 'button') but node.getAttribute(attr.nodeName) == 'add|remove|move-up|move-down' (as desired)
 						
 						//clone and process an event handler property (attribute);
@@ -2450,6 +1622,7 @@ $wf2 = {
 							attrValue = (processAttr ? processAttr(attrValue) : attrValue);
 							clone.setAttribute(attr.name, attrValue);
 						}
+						//console.log(StringHelpers.sprintf("AFTER attr: %s val: %s (%s)", attr.name, attr.value, processAttr(attrValue)))
 					}
 				}
 				//MSIE BUG: setAttribute('class') creates duplicate value attribute in MSIE; 
